

CREATE OR REPLACE FUNCTION fLabaRugiFix1 (
	_StartDate	DATE,
	_EndDate	DATE,
	_StartDateOld	DATE,
	_EndDateOld	DATE,
	_branchid	VARCHAR,
	_deptid		VARCHAR,
	_prjid		VARCHAR
) RETURNS SETOF tLabaRugi1 AS
$BODY$
DECLARE
	_retval		tLabaRugi1%ROWTYPE;
	_acctype1	VARCHAR;
	_acctypedesc1	VARCHAR;
	_accno		VARCHAR;
	_accname	VARCHAR;
	_acctype2desc	VARCHAR;
	_accbal		NUMERIC(19,4);
	_jum400		NUMERIC(19,4);
	_jum500		NUMERIC(19,4);
	_jum600		NUMERIC(19,4);
	_jum700		NUMERIC(19,4);
	_jum800		NUMERIC(19,4);
	_accbalOld	NUMERIC(19,4);
	_jum400Old	NUMERIC(19,4);
	_jum500Old	NUMERIC(19,4);
	_jum600Old	NUMERIC(19,4);
	_jum700Old	NUMERIC(19,4);
	_jum800Old	NUMERIC(19,4);
	_accdk		VARCHAR; 
	cAccType1	REFCURSOR;
	cAcc		REFCURSOR;
BEGIN
	OPEN cAccType1 FOR
		SELECT acctype,acctypedesc FROM acctype1 WHERE nr='R' ORDER BY acctype;
	LOOP
		FETCH cAccType1 INTO _acctype1,_acctypedesc1;
		EXIT WHEN NOT FOUND;

		IF(_acctype1='400') THEN
			SELECT INTO _jum400 (COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0))
			FROM jnld 
			JOIN jnl ON jnl.jnlno=jnld.jnlno 
			JOIN acc ON jnld.accno=acc.accno 
			LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype
			WHERE acctype1.acctype='400' AND JnlDate>=_StartDate AND JnlDate<=_EndDate AND (_branchid IS NULL OR jnl.branchid=_branchid) 
			AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid);

			IF(_StartDateOld IS NOT NULL AND _EndDateOld IS NOT NULL) THEN
				SELECT INTO _jum400Old 
				(COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0)) 
				FROM jnld 
				JOIN jnl ON jnl.jnlno=jnld.jnlno 
				JOIN acc ON jnld.accno=acc.accno 
				LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype
				WHERE acctype1.acctype='400' AND 
				JnlDate>=_StartDateOld AND JnlDate<=_EndDateOld AND (_branchid IS NULL OR jnl.branchid=_branchid) AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid);
			ELSE
				_jum400Old:=0;
			END IF;
		END IF;

		IF(_acctype1='500') THEN
			SELECT INTO _jum500 (COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0))
			FROM jnld 
			JOIN jnl ON jnl.jnlno=jnld.jnlno 
			JOIN acc ON jnld.accno=acc.accno 
			LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype
		WHERE acctype1.acctype='500' AND JnlDate>=_StartDate AND JnlDate<=_EndDate AND (_branchid IS NULL OR jnl.branchid=_branchid) AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid);

			IF(_StartDateOld IS NOT NULL AND _EndDateOld IS NOT NULL) THEN
				SELECT INTO _jum500Old 
				(COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0)) 
				FROM jnld 
				JOIN jnl ON jnl.jnlno=jnld.jnlno 
				JOIN acc ON jnld.accno=acc.accno 
				LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype
				WHERE acctype1.acctype='500' AND 
				JnlDate>=_StartDateOld AND JnlDate<=_EndDateOld AND (_branchid IS NULL OR jnl.branchid=_branchid) AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid);
			ELSE
				_jum500Old:=0;
			END IF;
		END IF;

		IF(_acctype1='600') THEN
			SELECT INTO _jum600 (COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0)) 
			FROM jnld 
			JOIN jnl ON jnl.jnlno=jnld.jnlno 
			JOIN acc ON jnld.accno=acc.accno 
			LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype
			WHERE acctype1.acctype='600' AND JnlDate>=_StartDate AND JnlDate<=_EndDate AND (_branchid IS NULL OR jnl.branchid=_branchid) AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid);

			IF(_StartDateOld IS NOT NULL AND _EndDateOld IS NOT NULL) THEN
				SELECT INTO _jum600Old 
				(COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0)) 
				FROM jnld 
				JOIN jnl ON jnl.jnlno=jnld.jnlno 
				JOIN acc ON jnld.accno=acc.accno 
				LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype
				WHERE acctype1.acctype='600' AND 
				JnlDate>=_StartDateOld AND JnlDate<=_EndDateOld AND (_branchid IS NULL OR jnl.branchid=_branchid) AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid);
			ELSE
				_jum600Old:=0;
			END IF;
		END IF;

		IF(_acctype1='700') THEN
			SELECT INTO _jum700 (COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0)) 
			FROM jnld 
			JOIN jnl ON jnl.jnlno=jnld.jnlno 
			JOIN acc ON jnld.accno=acc.accno 
			LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype
			WHERE acctype1.acctype='700' AND JnlDate>=_StartDate AND JnlDate<=_EndDate AND (_branchid IS NULL OR jnl.branchid=_branchid) AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid);

			IF(_StartDateOld IS NOT NULL AND _EndDateOld IS NOT NULL) THEN
				SELECT INTO _jum700Old 
				(COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0)) 
				FROM jnld 
				JOIN jnl ON jnl.jnlno=jnld.jnlno 
				LEFT JOIN acc ON jnld.accno=acc.accno 
				LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype
				WHERE acctype1.acctype='700' AND 
				JnlDate>=_StartDateOld AND JnlDate<=_EndDateOld AND (_branchid IS NULL OR jnl.branchid=_branchid) AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid);
			ELSE
				_jum700Old:=0;
			END IF;
		END IF;

		IF(_acctype1='800') THEN
			SELECT INTO _jum800 (COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0)) 
			FROM jnld 
			JOIN jnl ON jnl.jnlno=jnld.jnlno 
			JOIN acc ON jnld.accno=acc.accno 
			LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype
			WHERE acctype1.acctype='800' AND JnlDate>=_StartDate AND JnlDate<=_EndDate AND (_branchid IS NULL OR jnl.branchid=_branchid) AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid);

			IF(_StartDateOld IS NOT NULL AND _EndDateOld IS NOT NULL) THEN
				SELECT INTO _jum800Old 
				(COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0)) 
				FROM jnld 
				JOIN jnl ON jnl.jnlno=jnld.jnlno 
				JOIN acc ON jnld.accno=acc.accno 
				LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype
				WHERE acctype1.acctype='800' AND 
				JnlDate>=_StartDateOld AND JnlDate<=_EndDateOld AND (_branchid IS NULL OR jnl.branchid=_branchid) AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid);
			ELSE
				_jum800Old:=0;
			END IF;
		END IF;

		IF(_StartDateOld IS NOT NULL AND _EndDateOld IS NOT NULL)THEN
			OPEN cAcc FOR
				SELECT acc.accno,accname,acctype2desc,accdk
				FROM acc 
				LEFT JOIN jnld ON jnld.accno=acc.accno AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid)
				LEFT JOIN jnl ON jnl.jnlno=jnld.jnlno AND ((JnlDate>=_StartDate AND JnlDate<=_EndDate) or (JnlDate>=_StartDateOld AND JnlDate<=_EndDateOld)) AND (_branchid IS NULL OR jnl.branchid=_branchid) 
				LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype 
				LEFT JOIN acctype2 ON acctype2.acctype2=acc.acctype2
				WHERE acctype1.acctype=_acctype1
				GROUP BY acctype2desc,acc.accno,accname,accdk
				ORDER BY acc.accno;
		ELSE
			OPEN cAcc FOR
				SELECT acc.accno,accname,acctype2desc,accdk
				FROM acc 
				LEFT JOIN jnld ON jnld.accno=acc.accno AND (_deptid IS NULL OR jnld.deptid=_deptid) AND (_prjid IS NULL OR jnld.prjid=_prjid)
				LEFT JOIN jnl ON jnl.jnlno=jnld.jnlno AND (JnlDate>=_StartDate AND JnlDate<=_EndDate) AND (_branchid IS NULL OR jnl.branchid=_branchid)
				LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype 
				LEFT JOIN acctype2 ON acctype2.acctype2=acc.acctype2
				WHERE acctype1.acctype=_acctype1
				GROUP BY acctype2desc,acc.accno,accname,accdk
				ORDER BY acc.accno;
		END IF;
			LOOP
				FETCH cAcc INTO _accno,_accname,_acctype2desc,_accdk;
				EXIT WHEN NOT FOUND;

				SELECT INTO _AccBal 
				(COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0)) 
				FROM jnld 
				JOIN jnl ON jnl.jnlno=jnld.jnlno 
				JOIN acc ON jnld.accno=acc.accno 
				LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype 
				LEFT JOIN acctype2 ON acctype2.acctype2=acc.acctype2
				WHERE acctype1.acctype=_acctype1 AND acc.accno=_accno
				AND JnlDate>=_StartDate AND JnlDate<=_EndDate
				AND (_branchid IS NULL OR jnl.branchid=_branchid) 
				AND (_deptid IS NULL OR jnld.deptid=_deptid) 
				AND (_prjid IS NULL OR jnld.prjid=_prjid)
				GROUP BY acctype2desc,acc.accno,accname;

				IF(_StartDateOld IS NOT NULL AND _EndDateOld IS NOT NULL) THEN
					SELECT INTO _AccBalOld 
					(COALESCE(SUM(CASE WHEN dk=accdk THEN jnldamt ELSE -1*jnldamt END), 0)) 
					FROM jnld 
					JOIN jnl ON jnl.jnlno=jnld.jnlno 
					JOIN acc ON jnld.accno=acc.accno 
					LEFT JOIN acctype1 ON acctype1.acctype=acc.acctype 
					LEFT JOIN acctype2 ON acctype2.acctype2=acc.acctype2
					WHERE acctype1.acctype=_acctype1 AND acc.accno=_accno
					AND JnlDate>=_StartDateOld AND JnlDate<=_EndDateOld
					AND (_branchid IS NULL OR jnl.branchid=_branchid) 
					AND (_deptid IS NULL OR jnld.deptid=_deptid) 
					AND (_prjid IS NULL OR jnld.prjid=_prjid)
					GROUP BY acctype2desc,acc.accno,accname;
				END IF;

				_retval.accno:=_accno;
				_retval.accname:=_accname;
				_retval.acctype2desc:=_acctype2desc;
				_retval.acctype1:=_acctype1;
				_retval.acctypedesc1:=_acctypedesc1;
				_retval.jum400:=COALESCE(_jum400,0);
				_retval.jum500:=COALESCE(_jum500,0);
				_retval.jum600:=COALESCE(_jum600,0);
				_retval.jum700:=COALESCE(_jum700,0);
				_retval.jum800:=COALESCE(_jum800,0);
				_retval.jum400Old:=COALESCE(_jum400Old,0);
				_retval.jum500Old:=COALESCE(_jum500Old,0);
				_retval.jum600Old:=COALESCE(_jum600Old,0);
				_retval.jum700Old:=COALESCE(_jum700Old,0);
				_retval.jum800Old:=COALESCE(_jum800Old,0);
				_retval.accbal:=COALESCE(_accbal,0);
				_retval.accbalold:=COALESCE(_accbalold,0);
				RETURN NEXT _retval;
			END LOOP;
			CLOSE cAcc; 
	END LOOP;
	CLOSE cAccType1;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;


